import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class antarmies extends PApplet {

int RED = 0;
int BLACK = 1;

float GROUND = 300;
HashSet ants = new HashSet();
HashSet bullets = new HashSet();
Ant player;

public void setup(){
  size(1000,400);
  frameRate(40);
  player = new Ant(RED,200,100);
  ants.add(player);
  textFont(loadFont("Arial-Black-10.vlw"));
}
public void draw(){

  background(128,128,200);
  noStroke();
  fill(139,69,19);
  if(random(10) < 1){
    ants.add(new Ant(BLACK,width+20,GROUND-50)) ;
  }
  if(random(10) < 1){
    ants.add(new Ant(RED,-20,GROUND-50)) ;
  }

  rect(0,GROUND,width,height-GROUND);
  Iterator antit = ants.iterator();
  while(antit.hasNext()){
    Ant a = (Ant)antit.next(); 
    if(!a.move()){
      antit.remove();
    }
    a.draw();
  }
  Iterator bullit = bullets.iterator();
  while(bullit.hasNext()){
    boolean bulletgone = false;
    Bullet b = (Bullet)bullit.next(); 
    if(! b.move()){
      bullit.remove(); 
      bulletgone = true;
    }

    antit = ants.iterator();
    while(antit.hasNext()){
     Ant a = (Ant)antit.next(); 
      if(a.hitBy(b) ){
        a.die();
        if(!bulletgone) {
          bullit.remove();
         bulletgone = true; 
        }
      }
    }     

    b.draw();




  }

if(respawn){
       
        player = new Ant(RED,200,100);
        ants.add(player);
 respawn = false;
}
}


boolean respawn = false;
HashSet keysPressed = new HashSet();

public void keyPressed(){
//  print("up "+keyCode);
  keysPressed.add(keyCode);
}
public void keyReleased(){
  //print("down "+keyCode);

  keysPressed.remove(keyCode);

}


class Bullet{
  int dir; 
  float x,y;
  Bullet (float x, float y, int dir){
    this.x = x;
    this.y = y;
    this.dir = dir; 
  }
  public boolean move(){
    x = x + (dir * 3);
    if(x < -10) return false;
    if(x > width+10) return false;
    return true;
  }
  public void draw(){
    strokeWeight(2);
    stroke(0);
    fill(0);
    rect(x,y,1,1);
  }
}

class Ant {
  float x,y;
  int whatarmy;
  int mycolor;
  int dir;
  Ant(int whatarmy,float  x,float y){
    this.whatarmy = whatarmy;
    this.x = x;
    this.y = y; 
    if(whatarmy == RED){
      mycolor = color(128,0,0); 
      dir = 1;
    } 
    else {
      mycolor = color(64,64,64); 
      dir = -1;
    }

  }
  float ys;
  float GRAV = .4f;
  int gunrecharge = 0;
  public boolean move(){
    gunrecharge++;
    if(gunrecharge >= 100){
      gunrecharge = 100;  
    }



    if(this==player&& keysPressed.contains(90)){
      jump(); 
    }
    // println(keyCode);
    if(this==player&& keysPressed.contains(37)){

      dir = -1;
      x = x -1.5f;
    }
    if(this==player&& keysPressed.contains(39)){
      dir = 1;
      x = x +1.5f;
    }

    if(this == player && keysPressed.contains(88)){
      shoot();
    }
    if(this != player && alive){
      x =x + dir * 1.5f;
      if(random(10) < 1){
        jump(); 
      }
      if(random(30) < 1){
        shoot();
      }


    }

float REALHEIGHT;
if(alive){
    REALHEIGHT = H*1.2f;
  


    ys += GRAV;
    y = y + ys;

    if(y + H*1.2f >= GROUND){
      y = GROUND - REALHEIGHT;
      ys = 0; 
    }
} else {
   y = DIEHEIGHT; 
}

    if(this != player){
      if(dir < 0){
        if(x < -100){
          return false;
        }  
        else {
          if(x > width+100){
            return false;
          }           
        }

      }

    }

    return true;    
  }
boolean alive = true;
float DIEHEIGHT;
public void die(){
  if(! alive) return;
  DIEHEIGHT = GROUND-W;
Iterator antit = ants.iterator();
    while(antit.hasNext()){
    Ant a = (Ant)antit.next(); 
    if(! a.alive){
       if(x > a.x && x < a.x+H) {
         if(DIEHEIGHT > a.DIEHEIGHT - W){
         DIEHEIGHT = a.DIEHEIGHT - W;  
         }
         
       }
    }
  
  
    if(this == player){
        respawn = true;
      }


  }
  
  
 alive = false;
}

public boolean hitBy(Bullet b){
   if(b.x > x && b.x < x+W && b.y > y && b.y < y+H){
      return true; 
   } 
   return false;
}

  float W = 10    ;
  float H = 20;

  public void draw(){
    fill(mycolor);
    strokeWeight(2);
    stroke(0);
    pushMatrix();
    translate(x,y);
    if(alive){
    rect(0,0,W,H);
    line(0,H*.4f,-W*.5f,H*.75f);
    line(0,H*.7f,-W*.5f,H);
    line(0,H,-W*.5f,H*1.2f);

    line(W,H*.4f,W*1.5f,H*.75f);
    line(W,H*.7f,W*1.5f,H);
    line(W,H,W*1.5f,H*1.2f);

    fill(128);

    rect((-W*.25f) + (dir*(GUNW/2)),H*.5f, (W*1.5f),H*.2f) ;


    if(this==player){
      fill(color(255));
      text("YOU",-W/2,H*1.75f);
    }
    } else { //not alive
      rect(0,0,H,W);
    }
    popMatrix();
  }
  float GUNW = W*1.5f;
  public void shoot(){
    if(gunrecharge > 0){
      bullets.add(new Bullet(x+ (dir*(GUNW)),y+H*.5f,dir)); 
      gunrecharge = -20;
    }
  }

  public void jump(){
    if(y == (GROUND - H*1.2f)){
      ys = ys - 6; 
    }
  }




}



  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#d4d0c8", "antarmies" });
  }
}
